/* Lilygo T-Watch 2020 V1
   ESP32 Wrover 16MB Flash, 8/4 MB PSRAM
   by Markus Horbach
   18.04.2021
*/
#include <Arduino.h>
#include "freertos/FreeRTOS.h"
#include "freertos/task.h"
#include "freertos/timers.h"
#include "freertos/queue.h"
#include<stdio.h>
#include<string.h>
#include <esp_task_wdt.h>
//#include <WiFi.h>
//#include <BLE.h>

#include "myTWatch2020V1_defines.h"
#include "myTWatch2020V1_commands.h"
#include "myTWatch2020V1_UART_RX.h"
#include "myTWatch2020V1_ST7789.h"
#include "myTWatch2020V1_messages.h"

void setup() {
  // setup ESP32 watchdog
  esp_task_wdt_init(15, false);
  // setup UART CP2104
  Serial.begin(115200);
  Serial.println(TWatch_MSG_hello);
  Serial.println(TWatch_MSG_version);
  // TFT BL
  pinMode(ST7789V_TFT_BL , OUTPUT);
  digitalWrite(ST7789V_TFT_BL, HIGH);
  // InfraRot Diode
  pinMode(IR_Out , OUTPUT);
  // Vibrationsmotor
  //pinMode(VibMotorPin , OUTPUT);
  ledcSetup(VibPWMChannel, VibPWMFrequency, VibPWMResolution);
  ledcAttachPin(VibMotorPin, VibPWMChannel);
  // TFT ST7789

  // setup RTOS Queues + Tasks
  TaskHandle_t task1;
  xTaskCreatePinnedToCore( tsk_UART_RX, "UART RX", 10000, NULL, 1, &task1, 0);
  TaskHandle_t task2;
  xTaskCreatePinnedToCore( tsk_TFT_ST7789V, "TFT ST7789V", 10000, NULL, 1, &task2, 0);
}
// loop task
void loop() {
  esp_task_wdt_reset();

  delay(100);
}
