/* Lilygo T-Watch 2020 V1
   ESP32 Wrover 16MB Flash, 8/4 MB PSRAM
   by Markus Horbach
   18.04.2021
*/
#include "myTWatch2020V1_defines.h"
#include "myTWatch2020V1_commands.h"
#include "myTWatch2020V1_messages.h"
#include <Wire.h>
#include <axp20x.h>

void tsk_UART_RX( void * optionalArgs ) {
  // setup task
  Serial.println(TWatch_MSG_UART_Init);
  
  int in_uart = 0;
  // loop task
  for (;;) {
    if (Serial.available()) {
      in_uart = Serial.read();
      Serial.printf("CMD : %i\r\n", in_uart);
      if ( (in_uart >= TWatch_CMD_Idle) && (in_uart <= TWatch_CMD_ShowVersion) ) {
        // RTOS tools
        switch (in_uart) {
          case TWatch_CMD_Idle: {break;}
          case TWatch_CMD_selfreset: { ESP.restart();break;}
          case TWatch_CMD_ShowVersion: { Serial.println(TWatch_MSG_hello); Serial.println(TWatch_MSG_version); break;}
          default: break;
        }
      }
      // TFT Backlight control
      if ( (in_uart >= TWatch_CMD_TFT_BL_On) && (in_uart <= TWatch_CMD_TFT_BL_Off) ) {
        switch (in_uart) {
          case TWatch_CMD_TFT_BL_On : { digitalWrite(ST7789V_TFT_BL, HIGH);Serial.printf("BL on\r\n"); break;}
          case TWatch_CMD_TFT_BL_Off: { digitalWrite(ST7789V_TFT_BL, LOW); Serial.printf("BL off\r\n"); break;}
          default: break;
        }
      }
      // IR LED control
            if ( (in_uart >= TWatch_CMD_IR_LED_On) && (in_uart <= TWatch_CMD_IR_LED_Off) ) {
        switch (in_uart) {
          case TWatch_CMD_IR_LED_On : { digitalWrite(IR_Out, HIGH);Serial.printf("IR on\r\n"); break;}
          case TWatch_CMD_IR_LED_Off: { digitalWrite(IR_Out, LOW); Serial.printf("IR off\r\n"); break;}
          default: break;
        }
      }
      // Vibrationsmotor
      if ( (in_uart >= TWatch_CMD_VibOff) && (in_uart <= TWatch_CMD_VibMode3) ) {
        switch (in_uart) {
          case TWatch_CMD_VibOff   : { ledcWrite(VibPWMChannel,   0); Serial.printf("Vib Off%\r\n"); break;}
          case TWatch_CMD_VibOn    : { ledcWrite(VibPWMChannel, 255); Serial.printf("Vib  On%\r\n"); break;}
          case TWatch_CMD_VibMode0 : { ledcWrite(VibPWMChannel,  64); Serial.printf("Vib  25%\r\n"); break;}
          case TWatch_CMD_VibMode1 : { ledcWrite(VibPWMChannel, 128); Serial.printf("Vib  50%\r\n"); break;}
          case TWatch_CMD_VibMode2 : { ledcWrite(VibPWMChannel, 192); Serial.printf("Vib  75%\r\n"); break;}
          case TWatch_CMD_VibMode3 : { ledcWrite(VibPWMChannel, 255); Serial.printf("Vib 100%\r\n"); break;}
          default : break;
        }     
      }
      //in_uart = TWatch_CMD_Idle;
    }
    delay(1);
  }
}
